=== debian/control ===
Source: oxide-qt
Section: libs
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 8.0.0),
    cmake,
    qt5-qmake,
    qt5-default,
    qtdeclarative5-dev,
    qtbase5-private-dev,
    qtdeclarative5-private-dev,
    qtpositioning5-dev,
    ninja-build,
    python,
    pkg-config,
    libglib2.0-dev,
    libnss3-dev,
    libpci-dev,
    libgcrypt11-dev,
    libdbus-1-dev,
    libudev-dev,
    libpulse-dev,
    libasound2-dev,
    libx11-dev,
    libxi-dev,
    libcap-dev,
    libdrm-dev,
    libfontconfig1-dev,
    libfreetype6-dev,
    libpango1.0-dev,
    libxext-dev,
    libxcomposite-dev,
    libxrender-dev,
    libkrb5-dev,
    libssl-dev,
    libgdk-pixbuf2.0-dev,
    libnotify-dev,
    gperf,
    bison,
    xvfb,
    qtdeclarative5-qtquick2-plugin,
    qtdeclarative5-test-plugin,
    libexif-dev,
    libxcursor-dev,
    libxrandr-dev,
    libxtst-dev,
    libmedia-hub-dev [armhf],
    libandroid-properties-dev,
    libhybris-dev,
    libffi-dev
Standards-Version: 3.9.5
Homepage: https://launchpad.net/oxide

Package: liboxideqtcore0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
    ${misc:Depends},
    oxideqt-codecs (= ${binary:Version}) | oxideqt-codecs-extra (= ${binary:Version})
Description: Web browser engine for Qt (core library and components)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the core library, sandbox, renderer and support
 files required to run applications with Oxide

Package: liboxideqtcore-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
    ${misc:Depends},
    liboxideqtcore0 (= ${binary:Version})
Description: Web browser engine for Qt (development files for core library)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the development files required to compile programs
 against the Oxide core library

Package: liboxideqtquick0
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
    liboxideqtcore0 (= ${binary:Version}),
    oxideqt-codecs (= ${binary:Version}) | oxideqt-codecs-extra (= ${binary:Version})
Description: Web browser engine for Qt (QtQuick library)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the QtQuick library required to run QML applications
 with Oxide

Package: liboxideqtquick-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends},
    ${misc:Depends},
    liboxideqtquick0 (= ${binary:Version})
Description: Web browser engine for Qt (development files for QtQuick library)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the development files required to compile programs
 against the Oxide QtQuick library

Package: liboxideqt-qmlplugin
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
    liboxideqtcore0 (= ${binary:Version}),
    liboxideqtquick0 (= ${binary:Version})
Description: Web browser engine for Qt (QML plugin)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides the QML plugin required to run QML applications with
 Oxide

Package: oxideqt-codecs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: oxideqt-codecs-extra
Breaks: liboxideqtcore0 (<< 1.0.0~bzr488)
Replaces: oxideqt-codecs-extra, liboxideqtcore0 (<< 1.0.0~bzr488)
Description: Web browser engine for Qt (codecs)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides some media codecs needed for the HTML5 <audio> and
 <video> tags. Included are the free Theora, Vorbis, Opus, VP8 and VP9
 codecs

Package: oxideqt-codecs-extra
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: oxideqt-codecs
Breaks: liboxideqtcore0 (<< 1.0.0~bzr488)
Replaces: oxideqt-codecs, liboxideqtcore0 (<< 1.0.0~bzr488)
Description: Web browser engine for Qt (codecs)
 Oxide is a web browser engine library based on Chromium that makes it easy to
 embed web content in your Qt application
 .
 This package provides some media codecs needed for the HTML5 <audio> and
 <video> tags. Included are the Theora, Vorbis, Opus, VP8, VP9, MP3, AAC
 and H.264 codecs
